﻿//##############################################################################
//# G5-Scripts.de PHP Newsletter Script
//# Copyright 2004-2013 G5-Scripts.de webmaster@G5-Scripts.de
//# Last Modified                23.12.2014
//# G5-Scripts.de                http://www.G5-Scripts.de
//# Version                      1.2.9
//##############################################################################
//# Lizenzbedingungen (gekürzte Fassung)
//# Copyright 2004-2014 G5-Scripts.de  All Rights Reserved.
//#
//# Dieser Code stellt eine Erweiterung für das Hauptprogramm „Newsletter PHP“ 
//# von G5-Scripts.de bereit, es handelt sich hierbei um ein sogenanntes Zusatzmodul. 
//# Dieser Code kann und darf nur im Zusammenhang mit dem 
//# Hauptprogramm „Newsletter PHP“ genutzt werden.
//# 
//# Die Benutzung des Zusatzmoduls ist nur auf einer bei G5-Scripts.de 
//# lizenzierten Domain gestattet, dies geschieht i.d.R. durch einen käuflichen Erwerb 
//# des Zusatzmoduls über G5-Scripts.de.
//# 
//# Die Benutzung des Zusatzmoduls auf einer nicht lizenzierten Domain ist 
//# nicht gestattet und wir als ein Verstoß gegen das Lizenzabkommen und somit als 
//# eine Strafhandlung betrachtet.
//#
//##############################################################################

$(document).ready(function() {
    //info für die startseite
    NSL.pluginPublication('NSLTemplate');

    NSL.pluginAreaAddApp('NSLTemplateApp', 'NSLTemplate');
    NSL.pluginAreaAppAddText('NSLTemplateApp', 'Speichern und Wiederverwenden von Newsletter Layout Vorlagen (Templates)');

    //combo mit den template
    var templateIDClickDelegate = function() {
        var templID = parseInt($(document).find('#templateID').val(), 10);
        if (templID > 0) {
            $('#loadTemplate').css('opacity', '1');
            $('#deleteTemplate').css('opacity', '1');
        } else {
            $('#loadTemplate').css('opacity', '0.1');
            $('#deleteTemplate').css('opacity', '0.1');
        }
    };
    templateIDClickDelegate();
    $('#templateID').change(templateIDClickDelegate);

    //template load button
    $('#loadTemplate').click(function() {
        var templID = parseInt($(document).find('#templateID').val(), 10);
        if (templID > 0) {
            $('#formTmpl').submit();
        }
    });

    //template delete button
    $('#deleteTemplate').click(function() {
        var templID = parseInt($(document).find('#templateID').val(), 10);
        var templTitle = $(document).find('#templateID option:selected').text().trim();
        if (templID > 0) {
            if (confirm('Möchten Sie die Vorlage "' + templTitle + '" wirklich löschen?')) {

                var url = NSL.getMainDirURL();
                url += "/plugins/template/plugin.php";

                $.post(url, { 'delete': templID },
					function(response) {
					    var templID = parseInt(response, 10)
					    if (response == templID && templID > 0) {
					        $(document).find('#templateID').find('option[value="' + templID + '"]').remove();
					        if ($(document).find('#templateID').children().length <= 1) {
					            $('#templateLoader').fadeOut();
					        }
					    }
					});
                return true;
            }
        }
        return false;
    });

    //template save button
    $('#saveAsTemplate').click(function() {
        var tmplTitle = $('#templateTitle').val().trim();
        if (tmplTitle.length == 0) {
            NSL.alert("Bitte geben Sie eine Bezeichnung für die Vorlage ein!");
            $('#templateTitle').focus();
            return;
        }

        $('#saveAsTemplate').attr('disabled', true);

        var subject = $('#betreff').val();
        var content = (window.tinyMCE === undefined) ? $('#mailtext').val() : tinyMCE.get('mailtext').getContent();
        var overwrite = $('#overwriteTemplate').is(':checked');
        var saveCats = $('#saveCats').is(':checked');
        var selCats = $('#categorie').find('option:selected');
        var setAttachments = $('[name="attachment[]"]');
        
        var cats = [];
        if (selCats.length > 0) {
            selCats.each(function() {
                var val = $(this).val();
                cats.push(val);
            });
        }

        var attachments = [];
        if (setAttachments.length > 0) {
            setAttachments.each(function () {
                var val = $(this).val();
                attachments.push(val);
            });
        }

        var url = NSL.getMainDirURL();
        url += "/plugins/template/plugin.php";

        $.post(url, { 'save': 1, 'title': tmplTitle, 'subject': subject, 'content': content, 'overwrite': overwrite, 'saveCats': saveCats, 'cats': cats, 'attachments' : attachments },
					function(response) {
					    if (response != null) {
					        var templID = parseInt(response, 10);
					        if (response == templID && templID > 0) {
					            refreshCombo(templID);
					            $('#saveAsTemplate').removeAttr('disabled');
					            NSL.alert("Das Layout wurde erfolgreich als Vorlage gespeichert!");
					            return true;
					        } else {
					            NSL.alert("Das Layout konnte nicht gespeichert werden!");
					        }
					    }
					});
        return false;
    });

    function refreshCombo(setID) {
        var setID = parseInt(setID, 10);

        var url = NSL.getMainDirURL();
        url += "/plugins/template/plugin.php";

        $.get(url, { 'getComboElems': '' },
                   function(data) {
                       if (data != null && data.length > 0) {
                           $(document).find('#templateID').find('option[value!="0"]').remove();
                           $(document).find('#templateID').append($(data));
                           $(document).find('#templateID').val(setID);
                           $('#templateLoader').fadeIn();
                       }
                   });
    }
}); 