<?php
##############################################################################
# G5-Scripts.de PHP Newsletter Script
# Copyright 2004-2013 G5-Scripts.de webmaster@G5-Scripts.de
# Last Modified                23.12.2014
# G5-Scripts.de                http://www.G5-Scripts.de
# Version                      1.2.9
##############################################################################
# Lizenzbedingungen (gekürzte Fassung)
# Copyright 2004-2014 G5-Scripts.de  All Rights Reserved.
# 
# Mit dem Herunterladen bzw. Erwerb der hier angebotenen Software erkennen die Nutzer 
# ausdr&uuml;cklich die Lizenzbestimmungen gelesen und diese anerkannt zu haben.
#
# Beim Einsatz der Software im rein privaten Bereich ohne kommerzielle oder gewerbliche Absicht, 
# ist die Software f&uuml;r die Nutzung kostenfrei. F&uuml;r die kommerzielle Nutzung sowie 
# eine optionale Entfernung des Copyright Hinweises ist eine geeignete Lizenz zu erwerben.
#
# Diese Software darf im rein privaten Bereich frei benutzt werden, 
# solange alle Copyright bzw. Powered By Verweise auf G5-Scripts.de, 
# eingebaut innerhalb der Software, erhalten bleibt. Diese m&uuml;ssen f&uuml;r Benutzer sichtbar sein 
# und in unver&auml;nderter Form dargestellt werden.
#
# Die Original-Software unver&auml;ndert darf weitergegeben, jedoch nicht verkauft
# oder wiederverkauft werden.
# Die angepasste bzw. ver&auml;nderte Software und Teile dieser d&uuml;rfen nicht
# weitergegeben, verkauft oder wiederverkauft werden.
#
# Die vollst&auml;ndige Fassung der Lizenzbedingungen finden Sie unter:
# http://www.g5-scripts.de/scripte__newsletter_php__lizenzbedingungen.htm
#
# Dieser Code stellt eine Erweiterung f&uuml;r das Hauptprogramm „Newsletter PHP“ 
# von G5-Scripts.de bereit, es handelt sich hierbei um ein sogenanntes Zusatzmodul. 
# Dieser Code kann und darf nur im Zusammenhang mit dem 
# Hauptprogramm „Newsletter PHP“ genutzt werden.
# 
# Die Benutzung des Zusatzmoduls ist nur auf einer bei G5-Scripts.de 
# lizenzierten Domain gestattet, dies geschieht i.d.R. durch einen k&auml;uflichen Erwerb 
# des Zusatzmoduls &uuml;ber G5-Scripts.de.
# 
# Die Benutzung des Zusatzmoduls auf einer nicht lizenzierten Domain ist 
# nicht gestattet und wir als ein Versto&szlig; gegen das Lizenzabkommen und somit als 
# eine Strafhandlung betrachtet.
#
##############################################################################

if(basename( $_SERVER['PHP_SELF']) == basename(__FILE__)){
    ignore_user_abort(true);
    clearstatcache();
    if(file_exists("../../variablen.php")){include("../../variablen.php");}
    if(file_exists($script_pfad."/protected/subs.php")){include($script_pfad."/protected/subs.php");}
    
	if(!isset($in) || !is_array($in))
		$in = init_cgi();
	    
    $ISDEMO = file_exists("../../.demo");
}

if(isset($in['delete']) && is_numeric($in['delete'])){
    if(!$ISDEMO){
		$file = "$script_pfad/protected/data/templates/" . $in['delete'] . ".php" ;
		if(fileDelete($file))
			echo $in['delete'];
    }else{
	    echo $in['delete'];
    }

    exit;
}
elseif(isset($in['save']) && is_numeric($in['save'])){
    echo NSLTemplate::SaveTemplate($in);
    exit;
}
elseif(isset($in['getComboElems'])){
    $in = array();
    echo NSLTemplate::GetComboElems($in);
    exit;
}

class NSLTemplate
{
	private $entityPath;
	private $doc;

	public $id;
	public $title="";
	public $subject="";
	public $content="";
	public $categories="";
	public $attachments = array();
	
	public function __construct($entityPath, $id)
	{
		$id = (int)$id;
		$this->doc = new DOMDocument('1.0', 'UTF-8');
		$this->doc->formatOutput = true; 
		$this->doc->appendChild($this->doc->createElement('template'));

		$this->id = $id;
		$this->entityPath = $entityPath."/".$this->id.".php";
	}
	
	public function Load()
	{
		$entityFile = $this->entityPath;
		
		if(file_exists($entityFile)){
			@$ret = $this->doc->load($entityFile);
			
			if($ret){
				//ist XML
				$this->title    = $this->getValue("title");
				$this->subject	= $this->getValue("subject");
				$this->content  = $this->getValue("content");
				$this->categories= $this->getValue("categories");
				$this->attachments = $this->getValue("attachments");
				return true;
			}
		}
		
		return false;
	}
	public function Save()
	{
		$entityFile = $this->entityPath;
		
		$this->setValue("title",	$this->title);
		$this->setValue("subject",	$this->subject);
		$this->setValue("content",	$this->content);
		$this->setValue("categories",	$this->categories);
		$this->setValue("attachments",	$this->attachments);
		
		$this->doc->save($entityFile);
	}
	
	private function getValue($tagName){
		$val = "";
		$node = $this->doc->getElementsByTagName($tagName)->item(0);
		if($node != null){
			$val = $node->nodeValue;
			$val = base64_decode($val);
			$val = utf8_decode($val);
		}
		return $val;
	}
	private function setValue($tagName, $val){
		$root = $this->doc->getElementsByTagName("template")->item(0);
		$node = $this->doc->getElementsByTagName($tagName)->item(0);
		$val = utf8_encode($val);
		$val = base64_encode($val);
		$val = $this->doc->createCDATASection($val);
		
		if($node != null){
			$root->removeChild($node);
		}
		
		$newNode = $this->doc->createElement($tagName);
		$newNode->appendChild($val);
		
		$root->appendChild($newNode);
	}
	
	public static function GetFormularExtensionTop($in){
		global $script_pfad;
		
		$templates = NSLTemplate::GetTemplates();
		if(!is_array($templates)) return;
		
		
		$str = NSLTemplate::GetComboElems($in);
		$style = (strlen($str)==0) ? 'display: none;' : '';
		
		$dir = $script_pfad."/protected/data/templates";
		if(!is_dir($dir)){
			@mk_dir($dir);	
		}
		
		$str = '<div id="templateLoader" class="content" style="'.$style.'">
	    <table style="margin-left: auto; margin-right: 6px; border-collapse: collapse;">
	    <tr>
	    <td>
	    <form id="formTmpl" name="formTmpl" method="post" action="admin.php">
		    Newsletter Vorlage laden: 
		    <select id="templateID" name="templateID">
		    <option value="0">-- bitte ausw&auml;hlen --</option>
		    '.$str.'
		    </select>
		    <input type="hidden" name="ac" value="neue_newsletter">
	    </form>
			    </td>
	    <td><div id="loadTemplate" name="loadTemplate" class="LayoutLoad16"></div></td>
	    <td><div id="deleteTemplate" name="deleteTemplate" class="LayoutDelete16"></div></td>
			    </tr>
	    </table>
	    </div>
	';

		return $str;
	}
	public static function GetFormularExtensionBottom($templateTitle){
		return '
	    <td valign="top" width="33%">
		<div id="nslContainerTemplateSave" class="content" style="height: 160px;">
		<div class="caption">Aktuelles Layout als Vorlage speichern</div>
		<div>
		Bezeichnung f&uuml;r diese Vorlage:<br>
		<input type="text" id="templateTitle" name="templateTitle" value="'.$templateTitle.'" size="40" maxlength="50" style="width: 100%"><br>
		<input type="checkbox" id="overwriteTemplate" name="overwriteTemplate" value="1"> evtl. vorhandene Vorlage &uuml;berschreiben<br>
		<input type="checkbox" id="saveCats" name="saveCats" value="1"> ausgew&auml;hlte Kategorien mit speichern
		<input type="button" id="saveAsTemplate" name="saveAsTemplate" value="als Vorlage speichern">
		</div>
		</div>
	    </td>
	';
	}
	public static function GetComboElems($in){
		$templates = NSLTemplate::GetTemplates();
		if(!is_array($templates)) return '';
		
		$selectedID = is_array($in) && isset($in['templateID']) ? $in['templateID'] : "";
		$str = '';
		foreach($templates as $t){
			$str .= '<option value="'.$t->id.'" '.($t->id == $selectedID ? ' selected' : '').'>'.htmlspecialchars($t->title, ENT_QUOTES).'</option>';
		}
		return $str;
	}
	
	public static function LoadTemplate($in){
		global $script_pfad;
		if(!is_array($in))return;
		if(!isset($in['templateID'])) return;
		
		$e = new NSLTemplate("$script_pfad/protected/data/templates",$in['templateID']);
		$e->Load();
		return $e;
	}
	public static function SaveTemplate($in){
		global $ISDEMO;
		
		if(!$ISDEMO){
			global $script_pfad;
			if(!is_array($in))return;


			$time = time();
			if(!isset($in['title']) || strlen(trim($in['title'])) == 0)
				fehler("Bitte gebene Sie eine Bezeichnung f&uuml;r die Vorlage an!");

			$e = null;
			if(isset($in['overwrite']) && ($in['overwrite'] == 1 || $in['overwrite'] == true))
				$e = NSLTemplate::FindTemplate($in['title']);
			
			if(!is_object($e))
				$e = new NSLTemplate("$script_pfad/protected/data/templates",$time);
			
			$e->title		= get_magic_quotes_gpc() ? stripslashes($in['title']) : $in['title'];
			$e->subject		= get_magic_quotes_gpc() ? stripslashes($in['subject']) : $in['subject'];
			$e->content		= get_magic_quotes_gpc() ? stripslashes($in['content']) : $in['content'];
			
			if(isset($in['saveCats']) && ($in['saveCats'] == 1 || $in['saveCats'] == true))
				if(isset($in['cats']) && is_array($in['cats']) && count($in['cats']) > 0)
					$e->categories	= get_magic_quotes_gpc() ? stripslashes(implode(',', $in['cats'])) : implode(',', $in['cats']);
				
			if(isset($in['attachments']) && is_array($in['attachments']) && count($in['attachments']) > 0)
				$e->attachments	= get_magic_quotes_gpc() ? stripslashes(implode(',', $in['attachments'])) : implode(',', $in['attachments']);

			$e->Save();
			
			return $e->id;
		}
		return 0;
	}
	
	public static function GetTemplates(){
		global $script_pfad;
		
		$eintraege=array();
		$dir = "$script_pfad/protected/data/templates";
		if(!is_readable($dir)){
			fehler("Kann aus dem Verzeichnis \"$dir\" nicht lesen!");
		}else{
			$verz = opendir($dir);
			while ($file = readdir($verz)) {
				if(!preg_match('/^\./', $file)) {
					if(preg_match("/.php/", strtolower($file))){
						list($file,$ext)=explode(".", $file);
						$e = new NSLTemplate($dir, $file);
						$e->Load();
						array_push($eintraege, $e);
					}
				}
			}
			closedir($verz);
		}
		//usort($eintraege, "NSLTemplate::cmp");
		usort($eintraege, array("NSLTemplate", "cmp"));
		
		return $eintraege;
	}
	public static function FindTemplate($title){
		$templates = NSLTemplate::GetTemplates();
		if(!is_array($templates)) return;
		if(count($templates)==0) return;
		foreach($templates as $t){
			if($t->title == $title){
				return $t;
			}
		}
		return null;
	}
	static function cmp($a, $b)
	{
		return strcmp($a->title, $b->title);
	}
}

?>