﻿//##############################################################################
//# G5-Scripts.de PHP Newsletter Script
//# Copyright 2004-2013 G5-Scripts.de webmaster@G5-Scripts.de
//# Last Modified                23.12.2014
//# G5-Scripts.de                http://www.G5-Scripts.de
//# Version                      1.2.9
//##############################################################################
//# Lizenzbedingungen (gekürzte Fassung)
//# Copyright 2004-2014 G5-Scripts.de  All Rights Reserved.
//#
//# Dieser Code stellt eine Erweiterung für das Hauptprogramm „Newsletter PHP“ 
//# von G5-Scripts.de bereit, es handelt sich hierbei um ein sogenanntes Zusatzmodul. 
//# Dieser Code kann und darf nur im Zusammenhang mit dem 
//# Hauptprogramm „Newsletter PHP“ genutzt werden.
//# 
//# Die Benutzung des Zusatzmoduls ist nur auf einer bei G5-Scripts.de 
//# lizenzierten Domain gestattet, dies geschieht i.d.R. durch einen käuflichen Erwerb 
//# des Zusatzmoduls über G5-Scripts.de.
//# 
//# Die Benutzung des Zusatzmoduls auf einer nicht lizenzierten Domain ist 
//# nicht gestattet und wir als ein Verstoß gegen das Lizenzabkommen und somit als 
//# eine Strafhandlung betrachtet.
//#
//##############################################################################

$(document).ready(function () {
    //info für die startseite
    NSL.pluginPublication('NSLUpload');

    NSL.pluginAreaAddApp('NSLUploadApp', 'NSLUpload');
    var menuItem = null;
    var pluginDirURL = NSL.getMainDirURL() + '/plugins/upload';
    var adminUIURL = pluginDirURL + '/pluginAdminUI.php';
    var explorerDir = pluginDirURL + '/explorer';

    menuItem = NSL.pluginAreaAppAddLink('NSLUploadApp', 'NSLUploadFilemaneger', 'Dateimanger');
    if (menuItem !== undefined) {
        menuItem.unbind('click').click(function () {
            if ($('#NSLFileManager').length > 0) return;

            var fm = GetFileMangerForm("NSLFileManager",
                {
                    Width: 940,
                    Height: 400,
                    userfilesRoot: NSL.getScriptDirURL() + '/userfiles',
                    pluginDirURL: NSL.getScriptDirURL() + '/protected/plugins/upload'
                });
            NSL.pluginAreaContentAdd(fm);
        });
    }



    menuItem = NSL.pluginAreaAppAddLink('NSLUploadApp', 'NSLUploadInfo', 'Info');
    if (menuItem !== undefined) {
        menuItem.unbind('click').click(function () {
            $.get(adminUIURL, { 'get': 'info' }, function (data) {
                NSL.pluginAreaContentAdd(data);
            });
        });
    }


    //$.getScript(pluginDirURL + '/explorer/editor_plugin.js');
    

    if (tinymce !== undefined) {
        tinymce.create('tinymce.plugins.explorer', {
            init: function (ed, url) {
                // Register the command so that it can be invoked by using tinyMCE.activeEditor.execCommand('mceExample');
                ed.addCommand('mceExplorer', function () {
                    ed.windowManager.open({
                        file: explorerDir + '/dialogNoInsert.htm',
                        width: 700,
                        height: 420,
                        inline: 1
                    }, {
                        file_url: '', // Datei URL nach auswahl
                        file_size: '',
                        file_date: ''
                    });
                });

                ed.addCommand('mceExplorerFiles', function () {
                    ed.windowManager.open({
                        file: explorerDir + '/dialog.htm',
                        width: 700,
                        height: 420,
                        inline: 1
                    }, {
                        file_url: '', // Datei URL nach auswahl
                        file_size: '',
                        file_date: ''
                    });
                });

                ed.addCommand('mceExplorerImages', function () {
                    ed.windowManager.open({
                        file: explorerDir + '/dialog.htm',
                        width: 700,
                        height: 420,
                        inline: 1
                    }, {
                        file_url: '', // Datei URL nach auswahl
                        file_size: '',
                        file_date: '',
                        fileExtFilter: ['jpg', 'jpeg', 'gif', 'png', 'bmp']
                    });
                });

                ed.addCommand('mceExplorerMedia', function () {
                    ed.windowManager.open({
                        file: explorerDir + '/dialog.htm',
                        width: 700,
                        height: 420,
                        inline: 1
                    }, {
                        file_url: '', // Datei URL nach auswahl
                        file_size: '',
                        file_date: '',
                        fileExtFilter: ['mp4','m4v','ogv','webm', 'xap', 'swf','flv', 'dcr', 'mov','qt','mpg','mp3','mpeg', 'avi','wmv','wm','asf','asx','wmx','wvx', 'rm','ra','ram']
                    });
                });

                // Register example button
                ed.addButton('explorer', {
                    title: 'Dateimanager',
                    cmd: 'mceExplorer',
                    image: explorerDir + '/../plugin.png'
                });


                var onInit = function () {
                    var onOpen = function ()
                    {
                        if (this.params.plugin_url === undefined) return;
                        if (this.count <= 0) return;

                        var advimage = this.params.plugin_url.indexOf('advimage')!= -1;
                        var advlink = this.params.plugin_url.indexOf('advlink')!= -1;
                        var advmedia = this.params.plugin_url.indexOf('media')!= -1;

                        if (!(advimage || advlink || advmedia)) return;

                        var winID = this.lastId.replace('_wrapper', '');
                        var winObj = this.windows[winID];
                        var iframe = $(winObj.iframeElement.get());
                        iframe.load(function () {
                            //
                            var content = iframe.contents();
                            var imageCode = '<img id="fileManager" src="../../../plugins/upload/plugin_small.png" title="Dateimanager" align="middle"/>';

                            if(advimage){
                                var td = content.find('#srcbrowsercontainer'); if(td.length == 0) return;
                                var imgButton = $(imageCode);
                                td.append(imgButton);

                                imgButton.click(function () {
                                    var ed = tinymce.activeEditor;
                                        
                                    var onclose = function () {
                                        var imgURL = arguments[0].params.file_url;

                                        if (imgURL.length > 0) {
                                            var imgURLShort = imgURL.match(/[-_\w]+[.][\w]+$/i)[0];

                                            //ed.execCommand('mceRepaint');
                                            //ed.focus();
                                            var form = content.find('form').first();
                                                
                                            form.find('#src').attr('value', imgURL);
                                            form.find('#alt"').attr('value', imgURLShort);
                                            form.find('#title"').attr('value', imgURLShort);

                                            form.find('#src').change();
                                        }

                                        ed.windowManager.onClose.remove(onclose);
                                    }

                                    ed.windowManager.onClose.add(onclose);

                                    ed.execCommand("mceExplorerImages");
                                });

                                var src_list = content.find('#src_list');
                                if (src_list.length > 0)
                                    src_list.parent().parent().remove();
                            }
                            else if(advlink){
                                var td = content.find('#hrefbrowsercontainer, #popupurlbrowsercontainer'); if(td.length == 0) return;

                                td.each(function(){
                                    var imgButton = $(imageCode);
                                    $(this).append(imgButton);

                                    imgButton.click(function () {
                                        var ed = tinymce.activeEditor;
                                        
                                        var onclose = function () {
                                            var linkURL = arguments[0].params.file_url;

                                            if (linkURL.length > 0) {
                                                var linkURLShort = linkURL.match(/[-_\w]+[.][\w]+$/i)[0];

                                                //ed.execCommand('mceRepaint');
                                                //ed.focus();
                                                var form = content.find('form').first();
                                                
                                                form.find('#href').attr('value', linkURL);
                                                form.find('#popupurl').attr('value', linkURL);
                                                form.find('#title"').attr('value', linkURLShort);
                                                form.find('#popupname"').attr('value', linkURLShort);
                                            }

                                            ed.windowManager.onClose.remove(onclose);
                                        }

                                        ed.windowManager.onClose.add(onclose);

                                        ed.execCommand("mceExplorerFiles");
                                    });
                                });
                            }
                            else if(advmedia){
                                var td = content.find('#filebrowsercontainer'); if(td.length == 0) return;

                                td.each(function(){
                                    var imgButton = $(imageCode);
                                    $(this).append(imgButton);

                                    imgButton.click(function () {
                                        var ed = tinymce.activeEditor;
                                        
                                        var onclose = function () {
                                            var linkURL = arguments[0].params.file_url;

                                            if (linkURL.length > 0) {
                                                var linkURLShort = linkURL.match(/[-_\w]+[.][\w]+$/i)[0];

                                                //ed.execCommand('mceRepaint');
                                                //ed.focus();
                                                var form = content.find('form').first();
                                                
                                                form.find('#src').attr('value', linkURL);
                                                form.find('#src').change();
                                            }

                                            ed.windowManager.onClose.remove(onclose);
                                        }

                                        ed.windowManager.onClose.add(onclose);

                                        ed.execCommand("mceExplorerMedia");
                                    });
                                });
                            }
                        });
                    }

                    tinymce.activeEditor.windowManager.onOpen.add(onOpen);
                }
                tinymce.activeEditor.onInit.add(onInit);

            },
        });

        // Register plugin
        tinymce.PluginManager.add('explorer', tinymce.plugins.explorer);
    }
});

function GetFileMangerForm(key, options) {
    var settings = {
        userfilesRoot: './userfiles',
        pluginDirURL: './',
        Width: 700,
        Height: 350,
        ShowLeftExplorer: true,
        fileExtFilter: []
    }

    options = $.extend(settings, options);
        
    var adminUIURL = options.pluginDirURL + '/pluginAdminUI.php';

    var currentDir = '';
    var currentItem = null;
    var dlg = null;
    var fm = null;
    var ctxMenu = null;
    
    {
        var div = document.getElementById(key);
        if (div == null) {
            div = document.createElement("table");
            div.setAttribute("id", key);
            document.body.insertBefore(div, document.body.childNodes[0]);
        }
        fm = $(div);
    }
    
    fm.append($('<tr class="topRow"><td colspan="2" class="toolbar"></td></tr>'))
        .append($('<tr class="middleRow"><td class="leftSide"></td><td class="rightSide"></td></tr>'))
        .append($('<tr class="bottomRow"><td colspan="2" class="pathCell"></td></tr>'))
        .css('background', '#FFFFFF')
        .css('width', options.Width)
        .css('height', options.Height)
        .css('border', '1px solid black')
        .css('border-spacing', 1)
        .corner('2px')
        .disableTextSelect();

    var toolbar = $('.toolbar')
                    .css('height', 22)
                    .css('border', '1px solid #000000')
                    .css('padding', 2)
                    .corner('2px')
                    .addGradientBg('#509FD6', '#3584B2');

    var pathCell = $('.pathCell')
                    .css('height', 20)
                    .css('border', '1px solid #999999')
                    .corner('2px')
                    .text(' ');

    var leftSide = $('.leftSide')
                    .css('width', '25%')
                    .css('padding', 3)
                    .css('vertical-align', 'top')
                    .css('border', '1px solid #999999')
                    .css('overflow', 'auto')
                    .corner('2px');                    

    var rightSide = $('.rightSide')
                    .css('padding', 3)
                    .css('vertical-align', 'top')
                    .css('border', '1px solid #999999')
                    .css('overflow', 'auto')
                    .corner('2px');                    

    var btlExplorer = getTool('explorer', '', 'Verzeichnisexplorer ein- / ausblenden', options.pluginDirURL + '/img/explorer.png').css('width', 20).css('padding-left', 0);
    var btlRefresh = getTool('refresh', 'Aktualisieren', 'Aktualisieren', options.pluginDirURL + '/img/update.png');
    var btlUpload = getTool('upload', 'Hochladen', 'Hochladen', options.pluginDirURL + '/img/add.png');
    var btlRename = getTool('rename', 'Umbenennen', 'Umbenennen', options.pluginDirURL + '/img/rename.png');
    var btlDelete = getTool('delete', 'Löschen', 'Löschen', options.pluginDirURL + '/img/delete.png');
    var btlFolderAdd = getTool('folderAdd', 'Neuer Ordner', 'Neuer Ordner', options.pluginDirURL + '/img/folder_add.png');


    toolbar.append(btlExplorer);
    toolbar.append(btlRefresh);
    toolbar.append(btlUpload);
    toolbar.append(btlRename);
    toolbar.append(btlDelete);
    toolbar.append(btlFolderAdd);

    btlRefresh.click(function () { fm.Refresh(currentDir); });

    btlExplorer.click(function () {
        if (leftSide.is(":visible")) {
            btlExplorer.css('border-color', 'orange');
            leftSide.fadeOut();
        } else {
            btlExplorer.css('border-color', '');
            leftSide.fadeIn();
        }
    });

    btlUpload.click(function () {
        $.get(adminUIURL, { 'get': 'uploadForm' }, function (data) {
            var data = $(data);

            var buttonOK = BuildDialogButton('dialogBtnOK', 'OK', '#CCCCCC', '#AAAAAA').css('float', 'left');
            var buttonCancel = BuildDialogButton('dialogBtnCancel', 'Abbrechen', '#CCCCCC', '#AAAAAA').css('float', 'right');

            var settings = {
                Caption: 'Dateien hochladen',
                Content: data,

                OverlayLeft: fm.offset().left,
                OverlayTop: fm.offset().top,
                OverlayWidth: fm.outerWidth(),
                OverlayHeight: fm.outerHeight(),

                Left: fm.offset().left,
                Top: fm.offset().top,
                Width: 500,
                Height: 250,

                Buttons: [buttonOK, buttonCancel]
            }

            dlg = ShowDialog('uploadDialog', settings);

            dlg.BeforeShow = function () {
                //_unbindKeyDownEvent();
            };

            dlg.AfterClose = function (dialogResult) {
                //_bindKeyDownEvent();
                if (dialogResult != 'cancel')
                    fm.Refresh(currentDir);

                dlg = null;
            };

            buttonOK.click(function () {
                var iframes = data.find('iframe');

                iframes.each(function () {
                    var parent = $(this).parent();
                    var uplForm = $(this).contents().find("form");
                    var fileField = uplForm.find('input[name=file]');
                    if (fileField.val().length == 0)
                        parent.hide();
                });

                if (iframes.length > 0) {
                    //interessanter ansatz (ganz unten): http://stackoverflow.com/questions/30005/how-do-i-fire-an-event-when-a-iframe-has-finished-loading-in-jquery
                    var iframe = iframes.first();
                    var parent = iframe.parent();
                    var uplForm = iframe.contents().find("form");
                    var pathField = uplForm.find('input[name=path]');
                    pathField.val(currentDir);
                    var fileField = uplForm.find('input[name=file]');

                    if (fileField.val().length == 0) {
                        iframe.remove();
                        parent.remove();
                        buttonOK.click();
                        return;
                    }

                    iframe.load(function () {
                        var answer = iframe.contents().text().trim();

                        if (answer.length > 0) {
                            var elems = answer.split('|');
                            if (elems.length == 2) {
                                var code = elems[0];
                                var message = elems[1];
                                if (code == "0") {
                                    parent.css('background', 'url(' + options.pluginDirURL + '/img/error.png) no-repeat 2px center');
                                }
                                else if (code == "1") {
                                    parent.css('background', 'url(' + options.pluginDirURL + '/img/accept.png) no-repeat 2px center');
                                }
                                parent.css('padding-left', 25);
                                parent.text(message);
                            }
                        }

                        iframe.remove();
                        buttonOK.click();
                    });

                    iframe.hide();

                    parent.css('background', 'url(' + options.pluginDirURL + '/img/loading.gif) no-repeat 2px center');
                    parent.css('padding-left', 25);
                    parent.append('bitte warten...');

                    uplForm.submit();
                } else {
                    dlg.Close();
                }
            });

            buttonCancel.click(function () { dlg.Close('cancel'); });    //beim click auf 'cancel' dialog schließen

        });
    });

    btlFolderAdd.click(function () {
        $.get(adminUIURL, { 'get': 'createDirForm' }, function (data) {
            var data = $(data);

            var buttonOK = BuildDialogButton('dialogBtnOK', 'OK', '#CCCCCC', '#AAAAAA').css('float', 'left');
            var buttonCancel = BuildDialogButton('dialogBtnCancel', 'Abbrechen', '#CCCCCC', '#AAAAAA').css('float', 'right');
            var caption = 'Verzeichnis erstellen';
            var content = $('<div></div>')
                            .css('margin', 5)
                            .css('padding-left', 55)
                            .css('background', 'url(plugins/upload/img/folder_add32.png) no-repeat 5px 5px')
                            .append(data);

            var settings = {
                Caption: caption,
                Content: content,

                OverlayLeft: fm.offset().left,
                OverlayTop: fm.offset().top,
                OverlayWidth: fm.outerWidth(),
                OverlayHeight: fm.outerHeight(),

                Left: fm.offset().left,
                Top: fm.offset().top,
                Width: 320,
                Height: 150,

                Buttons: [buttonOK, buttonCancel]
            }

            dlg = ShowDialog('createDir', settings);

            dlg.BeforeShow = function () {
                //_unbindKeyDownEvent();
                var form = dlg.find('form');
                if (form.length > 0) {
                    var dirNameField = form.find('input[name=dirName]');
                    if (dirNameField.length > 0) {
                        dirNameField.focus();
                    }

                    form.submit(function () {
                        buttonOK.click();
                        return false;
                    });
                }
            };

            dlg.AfterClose = function (dialogResult) {
                //_bindKeyDownEvent();
                if (dialogResult != 'cancel')
                    fm.Refresh(currentDir);

                dlg = null;
            };

            buttonOK.click(function () {
                var path = currentItem.attr('path');
                var form = dlg.find('form');
                if (form.length > 0) {

                    var pathField = form.find('input[name=path]');
                    pathField.val(currentDir);
                    var dirNameField = form.find('input[name=dirName]');
                    var dirName = dirNameField.val().trim();

                    if (dirName.length == 0) {
                        NSL.alert('Bitte geben Sie einen Namen für das neue Verzeichnis ein!');
                        return;
                    }

                    var content = form.serialize();
                    $.post(adminUIURL, content)
                                .error(function () {
                                    NSL.alert('Es ist ein Fehler aufgetreten, der Vorgang kann nicht fortgesetzt werden!\nBitte versuchen Sie es erneut.');
                                    dlg.Close();
                                })
                                .success(function () {
                                    dlg.Close();
                                });
                }
            });

            buttonCancel.click(function () { dlg.Close('cancel'); });    //beim click auf 'cancel' dialog schließen
        });
    });

    btlDelete.click(function () {
        if (currentItem != null && currentItem !== undefined) {
            var name = currentItem.text();
            var path = currentItem.attr('path');
            var isFile = (currentItem.attr('class') == 'file');

            if (name == '..') return false;

            var buttonDelete = BuildDialogButton('dialogBtnDelete', 'Löschen', '#CCCCCC', '#AAAAAA').css('float', 'left');
            var buttonCancel = BuildDialogButton('dialogBtnCancel', 'Abbrechen', '#CCCCCC', '#AAAAAA').css('float', 'right');
            var caption = (isFile ? 'Dateien löschen' : 'Verzeichnis löschen');
            var content = (isFile ? 'Möchten Sie die Datei wirklich löschen?<br><br><b>' + name + '</b>' : 'Möchten Sie das Verzeichnis wirklich löschen?<br><br><b>' + name + '</b>');
            var icon = (isFile ? 'file_delete32.png' : 'folder_delete32.png');
            content = $('<div>' + content + '</div>')
                            .css('margin', 5)
                            .css('padding-left', 55)
                            .css('background', 'url(plugins/upload/img/' + icon + ') no-repeat 5px 5px');

            var settings = {
                Caption: caption,
                Content: content,

                OverlayLeft: fm.offset().left,
                OverlayTop: fm.offset().top,
                OverlayWidth: fm.outerWidth(),
                OverlayHeight: fm.outerHeight(),

                Left: fm.offset().left,
                Top: fm.offset().top,
                Width: 400,
                Height: 150,

                Buttons: [buttonDelete, buttonCancel]
            }

            dlg = ShowDialog('deleteDialog', settings);

            dlg.BeforeShow = function () {
                //_unbindKeyDownEvent();
            };

            dlg.AfterClose = function (dialogResult) {
                //_bindKeyDownEvent();
                if (dialogResult != 'cancel')
                    fm.Refresh(currentDir);

                dlg = null;
            };

            buttonDelete.click(function () {
                $.get(adminUIURL, { 'action': 'delete', 'path': path }, function (data) {
                    dlg.Close();
                });
            });

            buttonCancel.click(function () { dlg.Close('cancel'); });    //beim click auf 'cancel' dialog schließen
        }
    });

    btlRename.click(function () {
        if (currentItem != null && currentItem !== undefined) {
            var name = currentItem.text();
            var path = currentItem.attr('path');
            var isFile = (currentItem.attr('class') == 'file');

            if (name == '..') return false;

            $.get(adminUIURL, { 'get': (isFile ? 'renameFileForm' : 'renameDirForm') }, function (data) {
                var data = $(data);

                var buttonOK = BuildDialogButton('dialogBtnOK', 'OK', '#CCCCCC', '#AAAAAA').css('float', 'left');
                var buttonCancel = BuildDialogButton('dialogBtnCancel', 'Abbrechen', '#CCCCCC', '#AAAAAA').css('float', 'right');
                var caption = (isFile ? 'Datei umbenennen' : 'Verzeichnis umbenennen');
                var content = $('<div></div>')
                                .css('margin', 5)
                                .css('padding-left', 55)
                                .css('background', 'url(plugins/upload/img/rename32.png) no-repeat 5px 5px')
                                .append(data);

                var settings = {
                    Caption: caption,
                    Content: content,

                    OverlayLeft: fm.offset().left,
                    OverlayTop: fm.offset().top,
                    OverlayWidth: fm.outerWidth(),
                    OverlayHeight: fm.outerHeight(),

                    Left: fm.offset().left,
                    Top: fm.offset().top,
                    Width: 320,
                    Height: 150,

                    Buttons: [buttonOK, buttonCancel]
                }

                dlg = ShowDialog('renameForm', settings);

                dlg.BeforeShow = function () {
                    //_unbindKeyDownEvent();
                    var form = dlg.find('form');
                    if (form.length > 0) {
                        var oldNameField = form.find('input[name=oldName]');
                        if (oldNameField.length > 0) {
                            oldNameField.val(name);
                        }
                        var newNameField = form.find('input[name=newName]');
                        if (newNameField.length > 0) {
                            newNameField.val(name);
                            newNameField.focus().select();
                        }

                        form.submit(function () {
                            buttonOK.click();
                            return false;
                        });
                    }
                };

                dlg.AfterClose = function (dialogResult) {
                    //_bindKeyDownEvent();
                    if (dialogResult != 'cancel')
                        fm.Refresh(currentDir);

                    dlg = null;
                };

                buttonOK.click(function () {
                    var path = currentItem.attr('path');
                    var form = dlg.find('form');
                    if (form.length > 0) {
                        var pathField = form.find('input[name=path]');
                        pathField.val(currentDir);
                        var newNameField = form.find('input[name=newName]');
                        var newName = newNameField.val().trim();

                        if (newName.length == 0) {
                            if (isFile) {
                                NSL.alert('Bitte geben Sie einen neuen Namen für die Datei ein!');
                            } else {
                                NSL.alert('Bitte geben Sie einen neuen Namen für das neue Verzeichnis ein!');
                            }
                            return;
                        }

                        var content = form.serialize();
                        $.post(adminUIURL, content)
                                .error(function () {
                                    NSL.alert('Es ist ein Fehler aufgetreten, der Vorgang kann nicht fortgesetzt werden!\nBitte versuchen Sie es erneut.');
                                    dlg.Close();
                                })
                                .success(function () {
                                    dlg.Close();
                                });
                    }
                });

                buttonCancel.click(function () { dlg.Close('cancel'); });    //beim click auf 'cancel' dialog schließen
            });
        }
    });

    if (ctxMenu == null) {
        var div = document.getElementById('NSLUploadFilemanagerContextmenu');
        if (div == null) {
            div = document.createElement("div");
            div.setAttribute("id", 'NSLUploadFilemanagerContextmenu');
            document.body.insertBefore(div, document.body.childNodes[0]);
        }
        var ctxMenu = $(div);
        
        ctxMenu.empty();    //kontextmenü leeren, da sonst in bestimmten situationen die tools mehrfach eingefügt wurden
        
        ctxMenu.css('position', 'absolute')
                .css('z-index', 990)
                .css('width', 'auto')
                .css('height', 'auto')
                .css('border', '1px solid #999999')
                .corner('2px')
                .addGradientBg('#FFFFFF', '#EEEEEE')
                .disableTextSelect()
                .hide();

        toolbar.children().each(function () {
            if ($(this).attr('class') != 'explorer') {
                var btnOrig = $(this).clone()
                                    .css('float', 'none')
                                    .css('width', '180px')
                                    .css('margin-top', '1px')
                                    .css('margin-bottom', '1px')
                                    .css('padding-top', '2px')
                                    .css('padding-bottom', '2px')

                                    .css('font-weight', 'normal')
                                    .css('color', '#000000')
                                    .css('border', '1px solid #AAAAAA')

                                    .hover(
                                    function () {
                                        $(this).css('background-color', 'rgba(221,221,221,0.9)')
                                                .css('cursor', 'pointer');
                                    },
                                    function () {
                                        $(this).css('background-color', '')
                                                .css('cursor', 'default');
                                    })
                                    .click(function () {
                                        toolbar.find('.' + $(this).attr('class')).click();
                                    })

                                    .appendTo(ctxMenu);
            }
        });
    }

    fm.bind("contextmenu", function (e) {
        ctxMenu.css('left', e.pageX + 10).css('top', e.pageY + 10).show();
        if (ctxMenu.attr('shown') != '1') {
            ctxMenu.attr('shown', '1');
            ctxMenu.css('width', ctxMenu.width());
        }
        return false;
    });

    $(document).click(function (e) {
        //if (e.button == 0) {
        ctxMenu.hide();
        //}
    });

    fm.Refresh = function (path) {
        _unbindKeyDownEvent();

        if (path === undefined) path = '';

        currentDir = path;

        var filter = options.fileExtFilter.join(',');
        $.get(adminUIURL, { "_":new Date().getTime(), 'get': 'filelist', 'path': path, 'filter': filter }, function (data) {
            var data = $(data);

            data.css('margin', 0)
                .css('padding', 1)
                .css('font-size', 12)
                .css('padding-left', 22)
                .css('border', '1px solid #FFFFFF')
                .css('cursor', 'pointer');
                
            var folder = data.filter('.folder').clone();
            folder.css('font-weight', 'bold').css('background', 'url(' + options.pluginDirURL + '/img/folder.png) no-repeat 2px center');
            folder.sort(function (a, b) {
                var keyA = $(a).text();
                var keyB = $(b).text();
                if (keyA < keyB)
                    return -1;
                else if (keyA > keyB)
                    return 1;
                else
                    return 0;
            });

            var folder2 = folder.clone();
            var files = data.filter('.file').clone();
            files.css('background', 'url(' + options.pluginDirURL + '/img/other.png) no-repeat 2px center');
            files.sort(function (a, b) {
                var keyA = $(a).text();
                var keyB = $(b).text();
                if (keyA < keyB)
                    return -1;
                else if (keyA > keyB)
                    return 1;
                else
                    return 0;
            });

            leftSide.empty();
            rightSide.empty();

            var leftDiv = $('<div></div>')
                            .css('position', 'relative')
                            .css('width', '100%')
                            .css('height', '100%')
                            .css('padding', 0)
                            .css('margin', 0)
                            .css('overflow', 'auto');
                            
            var rightDiv = leftDiv.clone();
            
            leftSide.append(leftDiv);
            rightSide.append(rightDiv);

            leftDiv.append(folder);
            rightDiv.append(folder2).append(files);
            rightDiv.children().css('float', 'left').css('width', 180);

            var allItem = fm.find('.folder, .file');


            allItem.hover(function () {
                if (currentItem.text() != $(this).text() && currentItem.parent().parent().attr('class') == $(this).parent().parent().attr('class')) {
                    $(this)
                        .css('background-color', '#EEEEEE')
                        .css('border', '1px solid #CCCCCC');
                }
            },
            function () {
                if (currentItem.text() == $(this).text() && currentItem.parent().parent().attr('class') == $(this).parent().parent().attr('class')) {
                    $(this)
                        .css('background-color', '#33AAFF')
                        .css('border', '1px solid #000099');
                } else {
                    $(this)
                        .css('background-color', '')
                        .css('border', '1px solid #FFFFFF');
                }
            });

            allItem.mousedown(function () { SelectItem($(this)); });

            allItem.dblclick(function () {
                if($(this).attr('class') == 'file'){
                    var path = options.userfilesRoot + $(this).attr('path');
                    fm.dblclick(path);
                }else{
                    var path = $(this).attr('path');
                    fm.Refresh(path);
                }
            });

            _bindKeyDownEvent();

            var firstChild = rightDiv.children(':first-child');
            if (firstChild.length > 0) {
                SelectItem(firstChild);
            }
        });
    }

    fm.dblclick = function (filePath) {
        if (filePath !== undefined && filePath.length > 0) {
            window.open(filePath, "");
        }
    };

    function SelectItem(item) {
        if (currentItem != null && currentItem !== undefined) {
            if (currentItem.length > 0) {
                currentItem.css('background-color', '');
                currentItem.css('border', '1px solid #FFFFFF');
            }
        }

        currentItem = item;
        currentItem.css('background-color', '#33AAFF');
        currentItem.css('border', '1px solid #000099');

        var parent = currentItem.parent();
        var firstItem = parent.children(':first-child');
        var itemTop = currentItem.position().top - firstItem.position().top;
        var itemHeight = currentItem.outerHeight();
        if (itemTop + itemHeight > currentItem.parent().scrollTop() && itemTop + itemHeight > currentItem.parent().scrollTop() + parent.innerHeight())
            currentItem.parent().scrollTop(itemTop);
        else if (itemTop < currentItem.parent().scrollTop())
            currentItem.parent().scrollTop(itemTop);

        if (pathCell.length > 0) pathCell.text('{ROOT}' + currentItem.attr('path'));

        fm.currentIsFile = (currentItem.attr('class') == 'file');
        fm.currentPath = options.userfilesRoot + currentItem.attr('path');
        fm.filesize = currentItem.attr('filesize');
        fm.filedate = currentItem.attr('date');
    }

    function getTool(classname, text, tooltip, icon) {
        var t = $('<div></div>')
                    .addClass(classname)
                    .attr('title', tooltip)
                    .css('display', 'block')
                    .css('width', 100)
                    .css('height', 20)
                    .css('line-height', '20px')
                    .css('background-color', 'rgba(100,100,100,0.4)')
                    .css('border', '1px solid #CCCCCC')
                    .css('margin-left', 1)
                    .css('margin-right', 1)
                    .css('float', 'left')
                    .css('padding-left', 22)
                    .css('color', '#FFFFFF')
                    .css('font-weight', 'bold')
                    .css('font-size', 13)
                    .corner('2px')
                    .text(text);

        if (icon != null && icon !== undefined) {
            t.css('background', 'url(' + icon + ') no-repeat 2px center');
        }

        t.hover(function () {
            t.css('border-color', 'orange')
            t.css('background-color', 'rgba(100,100,100,0.7)')
            t.css('cursor', 'pointer')
        },
                    function () {
                        t.css('border-color', '#CCCCCC')
                        t.css('background-color', 'rgba(100,100,100,0.4)')
                        t.css('cursor', 'default')
                    });

        //.css('line-height', 22)
        return t;
    }

    /**
    * Navigation per Tastatur aktivieren (Events binden)
    *
    */
    function _bindKeyDownEvent() {
        _unbindKeyDownEvent();

        $(document).keydown(function (objEvent) {
            _keyboard_action(objEvent);
        });
    };
    /**
    * Navigation per Tastatur deaktivieren (Events trennen)
    *
    */
    function _unbindKeyDownEvent() {
        $(document).unbind('keydown');
    };

    /**
    * Auswertung der KeyDown Aktionen
    *
    */
    function _keyboard_action(objEvent) {
        // To ie
        var keycode = (objEvent == null) ? event.keyCode : objEvent.keyCode;

        // Get the key in lower case form
        key = String.fromCharCode(keycode).toLowerCase();

        if (dlg == null) {
            if (keycode == 37 || keycode == 38) {
                //pfeil links oder hoch
                if (currentItem != null && currentItem !== undefined) {
                    if (currentItem.length > 0) {
                        var prevItem = currentItem.prev();
                        if (prevItem.length == 0)
                            prevItem = currentItem.parent().children(':last-child');

                        if (prevItem.length > 0) {
                            SelectItem(prevItem);
                            objEvent.preventDefault();
                        }
                    }
                }
            }
            else if (keycode == 39 || keycode == 40) {
                    //pfeil rechts oder runter
                if (currentItem != null && currentItem !== undefined) {
                    if (currentItem.length > 0) {
                        var nextItem = currentItem.next();
                        if (nextItem.length == 0)
                            nextItem = currentItem.parent().children(':first-child');

                        if (nextItem.length > 0) {
                            SelectItem(nextItem);
                            objEvent.preventDefault();
                        }
                    }
                }
            }
            else if (keycode == 13) {
                    //return key
                if (currentItem != null && currentItem !== undefined) {
                    if (currentItem.length > 0) {
                        if (currentItem.attr('class') == 'folder') {
                            if (fm.currentIsFile) {
                                fm.dblclick(fm.currentPath);
                            } else {
                                fm.Refresh(fm.currentPath);
                            }
                        }
                    }
                }
            }
            else if (keycode == 113) {
                    //F2 - Key - rename
                if (currentItem != null && currentItem !== undefined) {
                    if (currentItem.length > 0) {
                        btlRename.click();
                    }
                }
            }
            else if (keycode == 46) {
                    //Del - Key - Delete
                if (currentItem != null && currentItem !== undefined) {
                    if (currentItem.length > 0) {
                        btlDelete.click();
                    }
                }
            }
        } else {
            if (keycode == 27) {
                //escape key
                dlg.Close('cancel');
            }
        }
    };


    fm.Refresh();

    if (settings.ShowLeftExplorer) {
        if (!leftSide.is(":visible")) {
            btlExplorer.click();
        }
    } else {
        if (leftSide.is(":visible")) {
            btlExplorer.click();
        }
    }

    return fm;
}

function ShowDialog(key, options) {

    var settings = {
        Caption: 'Caption',
        Content: 'Content text<bt>more text',

        OverlayShow: true,
        OverlayLeft: 0,
        OverlayTop: 0,
        OverlayWidth: 700,
        OverlayHeight: 300,

        Left: 0,
        Top: 0,
        Width: 700,
        Height: 300,

        Buttons: []
    }

    settings.OverlayWidth = windowWidth();
    settings.OverlayHeight = windowHeight();

    settings.Left = windowWidth() / 2 - settings.Width / 2;
    settings.Top = windowHeight() / 2 - settings.Height / 2;
    if (settings.Left < 0) settings.Left = 0;
    if (settings.Top < 0) settings.Top = 0;

    options = $.extend(settings, options);


    var div = document.getElementById(key);
    if (div == null) {
        div = document.createElement("div");
        div.setAttribute("id", key);
        document.body.insertBefore(div, document.body.childNodes[0]);
    }
    var main = $(div);

    var dialogBg = $('<div></div>')
                    .addClass('dialogBg')
                    .css('position', 'absolute')
                    .css('z-index', 998)
                    .appendTo(main);

    if (!options.OverlayShow) dialogBg.hide();

    var dialog = $('<div></div>')
                    .addClass('dialog')
                    .css('position', 'absolute')
                    .css('z-index', 999)
                    .hide()
                    .appendTo(main);


    var dialogCaption = $('<div></div>')
                    .css('position', 'absolute')
                    .css('top', 0)
                    .css('left', 0)
                    .css('height', 20)
                    .disableTextSelect()
                    .appendTo(dialog);

    var dialogContent = $('<div></div>')
                    .css('position', 'absolute')
                    .css('left', 0)
                    .css('padding', 3)
                    .appendTo(dialog);

    var dialogBottom = $('<div></div>')
                    .css('position', 'absolute')
                    .css('left', 0)
                    .css('bottom', 0)
                    .disableTextSelect()
                    .appendTo(dialog);


    main.BeforeShow = function() { };
    main.AfterClose = function(dialogResult) { };

    main.Close = function(dialogResult) {
        main.fadeOut(function() {
            $(div).remove();
            if (typeof main.AfterClose == 'function')
                main.AfterClose(dialogResult);
        });
    };

    main.update = function(newOptions) {
        options = $.extend(options, newOptions);

        //TODO die oberen draw zeilen alle durchlaufen, nur ohne append?
        //-> dabei müsse die 3 container vorher gecleared werden
        dialogBg.css('background', '#EEEEEE')
                    .css('opacity', '0.6')
                    .css('left', options.OverlayLeft)
                    .css('top', options.OverlayTop)
                    .css('width', options.OverlayWidth)
                    .css('height', options.OverlayHeight);

        if (!options.OverlayShow) dialogBg.hide();

        dialog.addGradientBg('#FFFFFF', '#EEEEEE')
                    .addShadow('#AAAAAA')
                    .css('left', options.Left + (dialogBg.outerWidth() / 2 - options.Width / 2))
                    .css('top', options.Top + (dialogBg.outerHeight() / 2 - options.Height / 2))
                    .css('width', options.Width)
                    .css('height', options.Height)
                    .css('border', '2px solid black')
                    .corner('10px');

        dialogCaption.empty()
                    .css('border-bottom', '1px solid black')
                    .corner('top 7px')
                    .css('color', 'white')
                    .css('font-weight', 'bold')
                    .css('font-size', '14px')
                    .css('text-align', 'center')
                    .css('vertical-align', 'middle')
                    .css('padding-top', 2)
                    .addGradientBg('#509FD6', '#3584B2')
                    .text(options.Caption);

        dialogBottom.empty()
                    .addGradientBg('#CCCCCC', '#EEEEEE')
                    .css('border-top', '1px solid black')
                    .corner('bottom 7px');


        dialogCaption.css('width', dialog.width());
        dialogContent.css('top', dialogCaption.outerHeight())
        dialogContent.css('width', dialog.width());
        dialogBottom.css('width', dialog.width());

        if (options.Buttons !== undefined && options.Buttons.length > 0) {
            for (var i = 0; i < options.Buttons.length; i++) {
                var button = options.Buttons[i];
                dialogBottom.append(button);
            }
        } else {
            dialogBottom.hide();
        }

        dialogContent.empty().append(options.Content);
    };


    main.update(options);
    dialog.fadeIn(function() {
        if (typeof main.BeforeShow == 'function')
            main.BeforeShow();
    });

    function windowWidth() {
        var windowWidth;
        if (self.innerHeight) {	// all except Explorer
            if (document.documentElement.clientWidth) {
                windowWidth = document.documentElement.clientWidth;
            } else {
                windowWidth = self.innerWidth;
            }
        } else if (document.documentElement && document.documentElement.clientHeight) { // Explorer 6 Strict Mode
            windowWidth = document.documentElement.clientWidth;
        } else if (document.body) { // other Explorers
            windowWidth = document.body.clientWidth;
        }
    }

    function windowHeight() {
        var windowHeight;
        if (self.innerHeight) {	// all except Explorer
            windowHeight = self.innerHeight;
        } else if (document.documentElement && document.documentElement.clientHeight) { // Explorer 6 Strict Mode
            windowHeight = document.documentElement.clientHeight;
        } else if (document.body) { // other Explorers
            windowHeight = document.body.clientHeight;
        }
    }

    return main;
}

function BuildDialogButton(className, caption, bgColor1, bgColor2, txtColor) {
    if (bgColor1 === undefined) bgColor1 = '#CCCCCC';
    if (bgColor2 === undefined) bgColor2 = '#AAAAAA';
    if (txtColor === undefined) txtColor = '#000000';

    var button = $('<div></div>')
                    .addClass(className)
                    .addGradientBg(bgColor1, bgColor2)
                    .css('opacity', 0.8)
                    .css('margin', 3)
                    .css('padding-top', 4)
                    .css('height', 20)
                    .css('width', 80)
                    .css('border', '2px solid black')
                    .corner('6px')
                    .css('text-align', 'center')
                    .css('vertical-align', 'middle')
                    .css('color', txtColor)
                    .css('cursor', 'pointer')
                    .hover(
                        function() {
                            $(this).css('opacity', 1);
                            $(this).css('color', 'blue');
                            $(this).css('border-color', 'blue')
                        },
                        function() {
                            $(this).css('opacity', 0.8);
                            $(this).css('color', txtColor);
                            $(this).css('border-color', 'black')
                        }
                    )
                    .text(caption);
    return button;
}