﻿//##############################################################################
//# G5-Scripts.de PHP Newsletter Script
//# Copyright 2004-2016 G5-Scripts.de webmaster@G5-Scripts.de
//# Last Modified                26.02.2016
//# G5-Scripts.de                http://www.G5-Scripts.de
//##############################################################################

var NSL = new function () {
    var _mainDirUrl=undefined;
    var _scriptDirUrl=undefined;
    this.Layout = 2;

    this.Styles = [
        new NslStyle('EEEEEE', 'CCCCCC'),
        new NslStyle('B7DBFF', '63A8ED'),
        new NslStyle('FFF8E5', 'F9CE61'),
        new NslStyle('F5FFD8', 'AEE57B'),
        new NslStyle('FFE5E5', 'FF8C8C'),
        new NslStyle('FEFCEA', 'EFE49E'),
        new NslStyle('7d7e7d', '0e0e0e', 'FFFFFF'),
        new NslStyle('606c88', '3f4c6b', 'FFFFFF'),
        new NslStyle('34589B', '09286B', 'FFFFFF')
    ];

    this.setLayout = function (layout) {
        var cookieKey = 'NSLStyle';
        if(layout === undefined){
            var ca = document.cookie.split(';');
            for(var i=0; i < ca.length; i++) {
                var c = ca[i];
                while (c.charAt(0)==' ') c = c.substring(1, c.length);
                if (c.indexOf(cookieKey) == 0){
                    var el = c.split('=');
                    layout = parseInt(el[1]);
                    break;
                }
            }
        }
        this.Layout = layout || this.Layout;

        var style = this.Styles[this.Layout];
        if (style !== undefined) {
            $('.caption').addGradientBg('#' + style.Bg1, '#' + style.Bg2);	//farbverlauf in allen caption rows
            $('.caption').css('color', '#' + style.Fg);

            $('#style').addGradientBg('#' + style.Bg1, '#' + style.Bg2);
        }

        $('input[type=button], input[type=submit]').addGradientBg('#EEEEEE', '#CCCCCC');

        document.cookie = cookieKey + '=' + this.Layout + '; expires=Thu, 31 Dec 2099 23:59:59 UTC; path=/';
    };


    /* ------------------------- Startseite ------------------------- */
    this.pluginPublication = function (pluginname) {
        $('.plugin[name=' + pluginname + ']').removeClass('red');
        $('.plugin[name=' + pluginname + ']').addClass('green');
    };

    /* ------------------------- PluginArea ------------------------- */
    this.pluginAreaAddApp = function (appName, appCaption) {
        if ($('#pluginAreaMenu').length == 0) return;
        var item = $('<table id="' + appName + '" style="float:left; margin: 5px;"><tr><td>&nbsp;</td><td><h3>' + appCaption + '</h3></td></tr></table>')
            .css('float', 'left')
            .css('padding', 5)
            .css('margin', 5)
            .css('width', 307)
            .css('height', 120)
            .css('border', '1px solid gray')
            .css('-webkit-border-radius', 5)
            .css('-moz-border-radius', 5)
	        .css('border-radius', 5)
            .css('-webkit-box-shadow', '5px 4px 3px #CCCCCC') /* webkit browser*/
            .css('-moz-box-shadow', '5px 4px 3px #CCCCCC') /* firefox */
            .css('box-shadow', '5px 4px 3px #CCCCCC');

        $('#pluginAreaMenu').append(item);

        item.find('td').css('vertical-align', 'top');
        item.find('td:first-child')
            .css('width', 50)
            .css('border-right', '1px dotted gray');
        item.find('h3')
            .css('padding', 0)
            .css('margin', 0)
            .css('margin-bottom', 4)
            .css('border-bottom', '1px solid orange');

        $('#pluginAreaMenu').css('height', item.position().top + item.outerHeight() - 90);
    };

    this.pluginAreaAppAddLink = function (appName, itemName, itemText) {
        if ($('#pluginAreaMenu').length == 0) return undefined;
        if ($('#' + appName).length == 0) return undefined;

        var item = $('<a name="' + itemName + '">' + itemText + '</a><br>')
            .css('cursor', 'pointer');

        $('#' + appName + ' td:last-child').append(item);


        return item;
    };
    this.pluginAreaAppAddText = function (appName, itemText) {
        if ($('#pluginAreaMenu').length == 0) return undefined;
        if ($('#' + appName).length == 0) return undefined;

        var item = $('<span>' + itemText + '</span><br>');

        $('#' + appName + ' td:last-child').append(item);


        return item;
    };

    this.pluginAreaContentAdd = function (content) {
        if ($('#pluginArea').length == 0) return;

        var me = this;
        me.pluginAreaContentClean();
        me.pluginAreaContentAppend(content);

        me.setLayout();
    };

    this.pluginAreaContentAppend = function (content) {
        if ($('#pluginArea').length == 0) return;

        var div = $('<div></div>')
            .addClass('content')
            .css('display', 'none')
            .append($(content))
            .appendTo($('#pluginArea'))
            .fadeIn('fast');
    };
    this.pluginAreaContentPrepend = function (content) {
        if ($('#pluginArea').length == 0) return;

        var div = $('<div></div>')
            .addClass('content')
            .css('display', 'none')
            .prepend($(content))
            .appendTo($('#pluginArea'))
            .fadeIn('fast');
    };
    this.pluginAreaContentClean = function () {
        if ($('#pluginArea').length == 0) return;

        if ($('#pluginArea').children().length > 0) {
            $('#pluginArea').empty().show();
        }
    };

    

    /* ------------------------- Allgemein ------------------------- */
    this.getMainDirURL = function () {
	if(_mainDirUrl === undefined){
	    var path = window.location.pathname;
	    var elems = path.split('/');
	    var last = elems[elems.length - 1];
	    path = path.replace(last, '');
	    if (path.charAt(path.length - 1) == '/') {
		path = path.substr(0, path.length - 1);
	    }
    
	    path = window.location.protocol + "//" + window.location.hostname + path;
	    
	    _mainDirUrl=path;
	}
        return _mainDirUrl;
    };
    this.getScriptDirURL = function () {
        if(_scriptDirUrl===undefined){
	    var _scriptDirUrl = this.getMainDirURL();
	    _scriptDirUrl = _scriptDirUrl.replace('protected', '');
	    if (_scriptDirUrl.charAt(_scriptDirUrl.length - 1) == '/') {
		_scriptDirUrl = _scriptDirUrl.substr(0, _scriptDirUrl.length - 1);
	    }
	}
        return _scriptDirUrl;
    };

    this.alert = function (message) {
        alert(message);
    };

    this.arrayContains = function (a, obj) {
        for (var i = 0; i < a.length; i++) {
            if (a[i] === obj) {
                return true;
            }
        }
        return false;
    }

    function NslStyle (bg1, bg2, fg) {
        this.Fg  = fg  || '000000';
        this.Bg1 = bg1 || '';
        this.Bg2 = bg2 || '';
    };
}

$(document).ready(function() {
    //javaScript test
    $('#jQueryTest').hide();

    $.extend($.fn.disableTextSelect = function() {
        return this.each(function() {
            if ($.browser.mozilla) {//Firefox
                $(this).css('MozUserSelect', 'none');
            } else if ($.browser.msie) {//IE
                $(this).bind('selectstart', function() { return false; });
            } else {//Opera, etc.
                $(this).mousedown(function() { return false; });
            }
        });
    });

    $.extend($.fn.addGradientBg = function(color1, color2) {
        return this.each(function() {
            $(this).css('background', color1)
                .css('background', '-moz-linear-gradient(top,  ' + color1 + ',  ' + color2 + ')')                                                   /* for firefox 3.6+ */
                .css('background', '-webkit-gradient(linear, left top, left bottom, from(' + color1 + '), to(' + color2 + '))')                     /* for webkit browsers */
                .css('background', 'o-linear-gradient(top,  ' + color1 + ',  ' + color2 + ')')                                                      /* for opera */
                .css('background', '-ms-linear-gradient(top,  ' + color1 + ',  ' + color2 + ')')                                                    /* for IE */
                .css('background', 'linear-gradient(top,  ' + color1 + ',  ' + color2 + ')');                                                       /* W3C Standard */
        });
    });

    $.extend($.fn.addShadow = function(color) {
        return this.each(function() {
            $(this).css('-webkit-box-shadow', '5px 4px 3px ' + color)
                    .css('-moz-box-shadow', '5px 4px 3px ' + color)
                    .css('box-shadow', '5px 4px 3px ' + color);
        });
    });

    $.extend($.fn.sortElements = function() {

        var sort = [].sort;

        return function(comparator, getSortable) {

            getSortable = getSortable || function() { return this; };

            var placements = this.map(function() {

                var sortElement = getSortable.call(this),
                parentNode = sortElement.parentNode,

                // Since the element itself will change position, we have
                // to have some way of storing its original position in
                // the DOM. The easiest way is to have a 'flag' node:
                nextSibling = parentNode.insertBefore(
                    document.createTextNode(''),
                    sortElement.nextSibling
                );

                return function() {

                    if (parentNode === this) {
                        throw new Error("You can't sort elements if any one is a descendant of another.");
                    }

                    // Insert before flag:
                    parentNode.insertBefore(this, nextSibling);
                    // Remove flag:
                    parentNode.removeChild(nextSibling);

                };

            });

            return sort.call(this, comparator).each(function(i) {
                placements[i].call(getSortable.call(this));
            });

        };
    });
    
    
    

    $('#einbaumoeglichkeiten').hide();

    $('#einbaumoeglichkeitenLink').css('cursor', 'pointer');
    $('#einbaumoeglichkeitenLink').click(function() {
        if ($('#einbaumoeglichkeiten').css('display') == 'none') {
            $('#einbaumoeglichkeiten').fadeIn('slow');
        } else {
            $('#einbaumoeglichkeiten').fadeOut('slow');
        }
    });

    if ($('#menu').length > 0) {
        var m = $('#menu');
        var btnStyle = $('<div id="style" title="Style w&auml;hlen" style="display: block; width: 16px; height: 16px; border: 1px solid gray; margin-top: 5px; margin-right: 5px; float: right; cursor: pointer"></div>');
        var panelStyles = $('<div id="styles" style="background: #FFFFFF; position: absolute; border: 1px solid gray; width: 80px; padding: 1px; -webkit-border-radius: 3px; -moz-border-radius: 3px; border-radius: 3px;"></div>').hide();


        var funcShowStylesMnu = function () {
            panelStyles.show(function () {
                $(document).bind('click', funcHideStylesMnu);
            });
        };
        var funcHideStylesMnu = function () {
            panelStyles.hide(function () {
                $(document).unbind('click', funcHideStylesMnu);
            });
        };


        for (var i = 0; i < NSL.Styles.length; i++) {
            var style = NSL.Styles[i];

            var btn = $('<div style="display: block; width: 16px; height: 16px; border: 1px solid gray; margin:1px; float: left; cursor: pointer"></div>');
            btn.attr('layoutID', i);
            btn.addGradientBg('#' + style.Bg1, '#' + style.Bg2);
            
            btn.click(function () {
                NSL.setLayout($(this).attr('layoutID'));
                funcHideStylesMnu();
            });

            panelStyles.append(btn);
        }

        m.append(btnStyle);
        m.append(panelStyles);

        panelStyles.css('left', btnStyle.position().left-2);
        panelStyles.css('top', btnStyle.position().top + btnStyle.outerHeight(true)+1);

        btnStyle.unbind('click').click(function () {
            funcShowStylesMnu();
        });
    }

    NSL.setLayout();

    //optionen
    if($('[name=maildelivery]').length > 0){
	    $('[name=maildelivery]').change(function(){
	        $('.infoPHPMail').hide();
	        $('.infoSendmail').hide();
	        $('.infoSMTPServer').hide();
	
	        switch($(this).val()){
		    case 'PHP mail()': $('.infoPHPMail').fadeIn(); break;
		    case 'sendmail': $('.infoSendmail').fadeIn(); break;
		    case 'SMTP-Server': $('.infoSMTPServer').fadeIn(); break;
	        }
	    });
	    $('[name=maildelivery]').change();
    }
    
    //test newsletter an admin
    var clickTestSenden = function() {
	    var sendToAdmin = $(this).attr('id') == 'sendToAdmin' ? true : false;
        var subject = $('#betreff').val().trim();
        var content = (window.tinyMCE === undefined || tinyMCE.get('mailtext') === undefined) ? $('#mailtext').val() : tinyMCE.get('mailtext').getContent();
	    var url = NSL.getMainDirURL() + "/admin.php";
	
        if (subject.length == 0) {
            alert("Bitte geben Sie einen Betreff ein!");
            $('#betreff').focus();
            return;
        }

        $(this).attr('disabled', true);

	    if(sendToAdmin){
	        $.post(url, { 'ac': 'send_letter_admin', 'betreff': subject, 'mailtext': content },
			    function(response) {
			        alert(response);
			        $('#sendToAdmin').removeAttr('disabled');
			    });
	    }else{
	        var adresse = prompt('Bitte geben Sie eine alternative E-Mail-Adresse ein:', '');
	    
	        $.post(url, { 'ac': 'send_letter_alternative', 'betreff': subject, 'mailtext': content, 'alternative': adresse },
			    function(response) {
			        alert(response);
			        $('#sendToAlternative').removeAttr('disabled');
			    });
	    }
    };
    $('#sendToAdmin').click(clickTestSenden);
    $('#sendToAlternative').click(clickTestSenden);
    
    //newsletter an user
    $('#sendToUser').click(function() {
        var subject = $('#betreff').val().trim();
        var content = (window.tinyMCE === undefined || tinyMCE.get('mailtext') === undefined) ? $('#mailtext').val() : tinyMCE.get('mailtext').getContent();
        var selCats = $('#categorie').find('option:selected');
        var nslID = 0;
        
        if (subject.length == 0) {
            alert("Bitte geben Sie einen Betreff ein!");
            $('#betreff').focus();
            return;
        }

        var attachments = [];
        if ($('[name="attachment[]"]').length > 0) {
            $('[name="attachment[]"]').each(function () {
                var val = $(this).val();
                attachments.push(val);
            });
        }
        
        var cats = [];
        if (selCats.length > 0) {
            selCats.each(function () {
                var val = $(this).val();
                cats.push(val);
            });
        }

        $('#sendToUser').attr('disabled', true);

        var url = NSL.getMainDirURL() + "/admin.php";

        //erst newsletter speichern
        $.post(url, { 'ac': 'saveLetter', 'betreff': subject, 'mailtext': content, "categorie": cats, "attachments": attachments },
	    function(response) {
		    if (response.length > 0) {
		        //newsletter erfolgreich gespeichert -> antwort beinhaltet alle empfänger
		        var rows = response.split("\n");            //zeilenweise
		        if (rows[rows.length - 1].length == 0)
			    rows.pop();                             //letztes element ist leer

		        if (rows.length > 0) {                      //haben auch mind. 1 empfänger
			        //container mit den kategorien ausblenden und dafür einen progress container einblenden
			        var parent = $('#nslContainerSendToUser').parent();

			        var counter = $('<div></div>')
			            .attr('id', 'nslProgressCounter')
			            .text('0/0')
			            .css('float', 'right');

			        var caption = $('<div></div>')
			            .addClass('caption')
			            .addGradientBg('#EEEEEE', 'orange')
			            .css('margin-bottom', '0px')
			            .text('Newsletter wird versendet...')
			            .append(counter);
			
			        var progressbarValue = $('<div></div>')
			            .attr('id', 'nslProgressbar')
			            .css('height', '100%')
			            .css('width', '0%')
			            .css('-webkit-box-sizing', 'border-box')
			            .css('-moz-box-sizing', 'border-box')
			            .css('box-sizing', 'border-box')
			            .css('padding', '0px')
			            .addGradientBg('#00FF00', '#00CC00');
			    
			        var progressbar = $('<div></div>')
			            .css('height', '5px')
			            .css('width', '100%')
			            .css('-webkit-box-sizing', 'border-box')
			            .css('-moz-box-sizing', 'border-box')
			            .css('box-sizing', 'border-box')
			            .css('border', '1px solid black')
			            .css('padding', '0px')
			            .append(progressbarValue);
			
			        var box = $('<div></div>')
			            .attr('id', 'nslProgressBox')
			            .css('height', '135px')
			            .css('overflow-y', 'scroll');

			        var newBox = $('#nslContainerSendToUser').clone()
			            .attr('id', 'nslProgress')
			            .empty()
			            .append(caption)
			            .append(progressbar)
			            .fadeOut(1)
			            .append(box);

			        $('#nslContainerSendToUser').fadeOut(function() {
			            parent.append(newBox);
			            newBox.fadeIn()

			            counter.attr('total', rows.length)
				           .text('0/' + rows.length);

			            //alle empfänger gleich in die progessbox einfügen, mit einem loading bildchen und state="0" (0 = unversenden, 1 = versendet)
			            while (rows.length > 0) {
				        var row = rows.shift();
				        var elems = row.split('|');
				        if (elems.length >= 2) {
				            var catID = elems[0];
				            var email = elems[1];
				            var nslID = elems[2];

				            box.append('<span class="Loading16" catID="' + catID + '" nslID="' + nslID + '" state="0" style="display: block;">' + email + '</span>');
				        }
			            }

			            //versand anstarten
			            sendMails();
			        });
		        }
		    } else {
		        alert("In den ausgewählten Kategorien sind noch keine Abonnenten vorhanden!");
		        $('#sendToUser').removeAttr('disabled');
		    }
	    });
    });

    function sendMails() {
        var entities = $('#nslProgressBox').find('span[catID!=""][state="0"]');
        var counter = $('#nslProgressCounter');
	    var progress = $('#nslProgressbar');
        var total = counter.attr('total');

        if (entities.length == 0) {
            if (total > 0) {
                alert('Fertig!\nIhr Newsletter wurde an ' + total + ' Abonnenten verschickt!');

                $('#nslProgress').fadeOut(function() {
                    $('#nslContainerSendToUser').fadeIn();
                    $('#sendToUser').attr('disabled', false);

                    $('#nslProgress').remove();
                });
            }
            return;
        }

        var first = entities.first();
        var catID = first.attr('catID');
        var nslID = first.attr('nslID');
        var email = first.text();

        counter.text((total - entities.length + 1) + '/' + total);
	    progress.css('width', ((total - entities.length + 1) / total * 100)+'%');
	
        var url = NSL.getMainDirURL() + "/admin.php";
        $.post(url, { 'ac': 'send_letter_user', 'email': email, 'cat': catID, "nslID": nslID },
	        function(response) {
		        if (response.length > 0) {
		            var elems = response.split('|');
		            if (elems.length == 4) {
			        var catID = elems[0];
			        var email = elems[1];
			        var nslID = elems[2];
			        var state = elems[3];

			        var entity = $('#nslProgressBox').find('span[catID!=""][state="0"][catID="' + catID + '"][nslID="' + nslID + '"]:contains(' + email + ')');
			        if (entity.length > 0) {
			            var item = entity;
			            //var item = entity.first();	//nur für debugzwecke
			            item.attr('state', '1');
			            if (state == "1")
				            item.attr('class', 'Accept16');
			            else
				            item.attr('class', 'Cancel16');

			            $('#nslProgressBox').scrollTop(item.index() * item.height());
			        }
		            }
		        }
	        }).error(function(xhr, status, error) {
		        alert('Es ist ein Fehler aufgetreten, der Vorgang kann nicht fortgesetzt werden!\n\n'+ xhr.responseText);
		        if (confirm("Fehler ignorieren und trotzdem fortsetzen?")) {
		            sendMails();
		        }		
	        })
	        .success(function() {
		        sendMails();
	        });
    }


    if ($('.info').length > 0) {
        var info = $('.info');
        var btn = $('.showinfo');
        info.hide();
        btn.css('cursor', 'pointer').html('&#9660;');
        btn.click(function () {
            if (info.is(":visible")) {
                info.hide();
                btn.html('&#9660;');
            }
            else {
                info.fadeIn(500, function () {
                    info.show()
                });                
                btn.html('&#9650;');
            }
            return false;
        });
    }
    if ($('.passwdext').length > 0) {
        $('.passwdext').hide();
        $('.showpasswdext').click(function () {
            $('.passwdext').show();
            return false;
        });
    }
});


